//+------------------------------------------------------------------+
//|                                                   SMRI/Emonts.mq4|
//+------------------------------------------------------------------+
#property copyright "Copyright  2014 SMRI/Emonts"
#property link      "--"

//---- indicator settings
#property  indicator_separate_window
#property  indicator_buffers 3
#property  indicator_color1  Lime
#property  indicator_color2  Gray
#property  indicator_color3  Red
#property  indicator_width1  4
#property  indicator_width2  4
#property  indicator_width3  4
#property indicator_minimum  0
#property indicator_maximum  1.0

//---- indicator parameters
extern string   __Parameters__         = "--";
// nihilist indi's
extern int      ADX_7                  = 7;
extern int      ADX_21                 = 21;
extern int      ADX_42                 = 42;
extern int      ADX_77                 = 77;


extern bool     Include_Dhruba         = true;
extern bool     Include_Magic          = true;
extern bool     Include_HolyGrail      = true;

//---- Alert parameters

extern bool    ShowChartAlerts     = true;                                                                                                     
string         AlertEmailSubject   = "SMRI Alert";                                                                                                                                                                                                                                                 //
datetime       LastAlertTime       = -999999;                                                                                                                                                                                                                                                  
string         AlertTextCrossUp    = "UP Alert";          
string         AlertTextCrossDown  = "DOWN Alert";




//---- indicator buffers
double     BufferUp[];
double     BufferFlat[];
double     BufferDown[];




//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- drawing settings
   IndicatorBuffers(3);
   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexStyle(2,DRAW_HISTOGRAM);
   
   
//---- indicator buffers mapping
   SetIndexBuffer(0,BufferUp);
   SetIndexBuffer(1,BufferFlat);
   SetIndexBuffer(2,BufferDown);
  
   
//---- initialization done
   return(0);
  }

int start()
  {
   bool dhruba_up = false;
   bool dhruba_down = false;
   bool magic_up = false;
   bool magic_down = false;
   bool HolyGrail_up = false;
   bool HolyGrail_down = false;
   
   int limit;
   int counted_bars=IndicatorCounted();
   
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
//---- 
      
      for(int i=0; i<limit; i++)
      {
         double Ni_ADX_11 = iCustom(Symbol(),0,"Nihilist_Ultra_ADX", ADX_7,0,i);
         double Ni_ADX_12 = iCustom(Symbol(),0,"Nihilist_Ultra_ADX", ADX_7,1,i);
         double Ni_ADX_13 = iCustom(Symbol(),0,"Nihilist_Ultra_ADX", ADX_7,2,i);
         double Ni_ADX_14 = iCustom(Symbol(),0,"Nihilist_Ultra_ADX", ADX_7,3,i);
         
         double Ni_ADX_21 = iCustom(Symbol(),0,"Nihilist_Ultra_ADX", ADX_21,0,i);
         double Ni_ADX_22 = iCustom(Symbol(),0,"Nihilist_Ultra_ADX", ADX_21,1,i);
         double Ni_ADX_23 = iCustom(Symbol(),0,"Nihilist_Ultra_ADX", ADX_21,2,i);
         double Ni_ADX_24 = iCustom(Symbol(),0,"Nihilist_Ultra_ADX", ADX_21,3,i);
         
         double Ni_ADX_31 = iCustom(Symbol(),0,"Nihilist_Ultra_ADX", ADX_42,0,i);
         double Ni_ADX_32 = iCustom(Symbol(),0,"Nihilist_Ultra_ADX", ADX_42,1,i);
         double Ni_ADX_33 = iCustom(Symbol(),0,"Nihilist_Ultra_ADX", ADX_42,2,i);
         double Ni_ADX_34 = iCustom(Symbol(),0,"Nihilist_Ultra_ADX", ADX_42,3,i);
         
         double Ni_ADX_41 = iCustom(Symbol(),0,"Nihilist_Ultra_ADX", ADX_77,0,i);
         double Ni_ADX_42 = iCustom(Symbol(),0,"Nihilist_Ultra_ADX", ADX_77,1,i);
         double Ni_ADX_43 = iCustom(Symbol(),0,"Nihilist_Ultra_ADX", ADX_77,2,i);
         double Ni_ADX_44 = iCustom(Symbol(),0,"Nihilist_Ultra_ADX", ADX_77,3,i);
         
         
         // retrieve values Magic indi
         if (Include_Magic)
         {
            double Nihilist_Magic_1 = iCustom(Symbol(), 0, "NIhilist_Magic",0, 0, i);
            double Nihilist_Magic_2 = iCustom(Symbol(), 0, "NIhilist_Magic",0, 1, i);
            
            magic_up = false;
            if (Nihilist_Magic_1 > 0)
            {
               magic_up = true;
            }
            magic_down = false;
            if (Nihilist_Magic_2 > 0)
            {
               magic_down = true;
            }
         }
         else
         {
            magic_up = true;
            magic_down = true;
         }
         
         // retrieve values HolyGrail indi
         if (Include_HolyGrail)
         {
            double Nihilist_HG_3 = iCustom(Symbol(), 0, "Nihilist_HolyGrail",0, 2, i);
            double Nihilist_HG_4 = iCustom(Symbol(), 0, "Nihilist_HolyGrail",0, 3, i);
            double Nihilist_HG_5 = iCustom(Symbol(), 0, "Nihilist_HolyGrail",0, 4, i);
            double Nihilist_HG_6 = iCustom(Symbol(), 0, "Nihilist_HolyGrail",0, 5, i);
            double Nihilist_HG_7 = iCustom(Symbol(), 0, "Nihilist_HolyGrail",0, 6, i);
            HolyGrail_up = false;
            if ((Nihilist_HG_3 == 1) || (Nihilist_HG_5 == 1))
            {
               HolyGrail_up = true; 
            }
            HolyGrail_down = false;
            if ((Nihilist_HG_4 == 1) || (Nihilist_HG_6 == 1))
            {
               HolyGrail_down = true; 
            }
         }
         else
         {
            HolyGrail_up = true;
            HolyGrail_down = true;
         }
         
         // retrieve values Dhruba indi
         if (Include_Dhruba)
         {
            double Nihilist_DHR_1 = iCustom(Symbol(), 0, "Nihilist_Dhruba",0, 0, i);
            double Nihilist_DHR_2 = iCustom(Symbol(), 0, "Nihilist_Dhruba",0, 1, i);
            double Nihilist_DHR_3 = iCustom(Symbol(), 0, "Nihilist_Dhruba",0, 2, i);
            double Nihilist_DHR_4 = iCustom(Symbol(), 0, "Nihilist_Dhruba",0, 3, i);
            dhruba_up = false;
            if ((Nihilist_DHR_1 == 1) || (Nihilist_DHR_3 == 1))
            {
               dhruba_up = true;
            }
            dhruba_down = false;
            if ((Nihilist_DHR_2 == 1) || (Nihilist_DHR_4 == 1))
            {
               dhruba_down = true;
            }
         }
         else
         {
            dhruba_up = true;
            dhruba_down = true;
         }

         
                 
         BufferUp[i]=EMPTY_VALUE;;
         BufferFlat[i]=1;
         BufferDown[i]=EMPTY_VALUE;
         
         if (((Ni_ADX_11 == 1) || (Ni_ADX_13 == 1)) && ((Ni_ADX_21 == 1) || (Ni_ADX_23 == 1)) 
               && ((Ni_ADX_31 == 1) || (Ni_ADX_33 == 1)) && ((Ni_ADX_41 == 1) || (Ni_ADX_43 == 1)) 
               && (magic_up)
               && (HolyGrail_up) && (dhruba_up) )
         {
            BufferUp[i]=1;
            BufferFlat[i]=EMPTY_VALUE;
         }
         
         if (((Ni_ADX_12 == 1) || (Ni_ADX_14 == 1)) && ((Ni_ADX_22 == 1) || (Ni_ADX_24 == 1)) 
               && ((Ni_ADX_32 == 1) || (Ni_ADX_34 == 1)) && ((Ni_ADX_42 == 1) || (Ni_ADX_44 == 1)) 
               && (magic_down)
               && (HolyGrail_down) && (dhruba_down))
         {
            BufferDown[i]=1;
            BufferFlat[i]=EMPTY_VALUE;
         }
      }
      
      ProcessAlerts(); //Alert check
//---- done
   return(0);
  }
//+------------------------------------------------------------------+

int ProcessAlerts()   {                                                                                                                         
//+------------------------------------------------------------------+                                                                          
  if (Time[0] > LastAlertTime)   
  {                                                                                        
      if ((BufferUp[1] == 1 && BufferUp[2] == EMPTY_VALUE) || (BufferUp[1] == 1 && BufferDown[2] == 1)  )  
      {                   
         string AlertText = Symbol() + "," + TFToStr(Period()) + ": " + AlertTextCrossUp;                                                          
         if (ShowChartAlerts)          Alert(AlertText);                                                                                           
         if (AlertEmailSubject > "")   SendMail(AlertEmailSubject,AlertText);                                                                      
         LastAlertTime = Time[0];                                                                                                                 
      } 

      if ((BufferDown[1] == 1 && BufferDown[2] == EMPTY_VALUE) || (BufferDown[1] == 1 && BufferUp[2] == 1)  )  
      {                
         AlertText = Symbol() + "," + TFToStr(Period()) + ": " + AlertTextCrossDown;      
                  if (ShowChartAlerts)          Alert(AlertText);                    
         if (AlertEmailSubject > "")   SendMail(AlertEmailSubject,AlertText);     
         LastAlertTime = Time[0]; 
      } 
  }
  return(0);  
}    

//+------------------------------------------------------------------+ 
string TFToStr(int tf)   {     
//+------------------------------------------------------------------+ 
  if (tf == 0)        tf = Period(); 
  if (tf >= 43200)    return("MN"); 
  if (tf >= 10080)    return("W1"); 
  if (tf >=  1440)    return("D1"); 
  if (tf >=   240)    return("H4");  
  if (tf >=    60)    return("H1"); 
  if (tf >=    30)    return("M30"); 
  if (tf >=    15)    return("M15"); 
  if (tf >=     5)    return("M5"); 
  if (tf >=     1)    return("M1"); 
  return(""); 
}